# VGg[`FbN
# entrychar.csv  newchar.csv }[WAǂ݂ȂŃ\[g
# ientrytitle.csv QlɍXV

use encoding "shiftjis";

#######################
sub init_entrychar {

    $titlefile = "entrytitle.csv";
    $charfile = "entrychar.csv";
    $newcharfile = "newchar.csv";

    @entryt = ();  # 0..ǂ݂  1..i  2..sS
    @entryc = ();  # 0..iǂ݂  1..Oǂ݂  2..O  3..i  4..iԍ
                   # 5..Gg[^U  6..ʖXg
    %entrytn = (); # $entry{i} = entryt̔ԍ
    %entrycn = (); # $entry{Oi} = entryc̔ԍ
    @entryto = (); # $entryto[iԍ] = i̕я

    $entrytno = 0; # o^i
    $entrycno = 0; # o^L

    $entryt[0][0] = "*io^*";

    @tmptime = localtime(time);
    $timestr = sprintf("%02d/%02d %02d:%02d", 
		       $tmptime[4]+1, $tmptime[3], $tmptime[2], $tmptime[1]);

}

#######################

unless($tkflag) {

    &main_entrychar();

    exit(0);

}

####### C[`

sub main_entrychar {

    &init_entrychar();
    &readentry_ec();
    &output_newentry();

}

######## C[`I


######## Tu[`

# entrytitle.csv, entrychar.csv ǂݍ
sub readentry_ec {

#    @entryt  # 0..ǂ݂  1..i  2..sS
    if(-e $titlefile) {
	open CSV, "<:encoding(shift-jis)", $titlefile;
	while(<CSV>) {
	    chop;
	    if(/,/) {
		$entrytno++;
		$entryt[$entrytno][2] = $_;
		@tmp = split(/,/);
		$entryt[$entrytno][0] = $tmp[0];
		$entryt[$entrytno][1] = $tmp[1];
		shift(@tmp);
		foreach (@tmp) {
		    $entrytn{$_} = $entrytno;
		}
		$entryto[$entrytno] = $entrytno + 1000;
	    }
	}
    }
    $entrytno0 = $entrytno;

#    @entryc   # 0..iǂ݂  1..Oǂ݂  2..O  3..i  4..iԍ
    if(-e $charfile) {
	open CSV, "<:encoding(shift-jis)", $charfile;
	while(<CSV>) {
	    chop;
	    if(/,/) {
		$entrycno++;
		$entryc[$entrycno][6] = $_;
		@tmp = split(/,/);
		$entryc[$entrycno][6] =~ s/^.*?,.*?,.*?,//;
		$entryc[$entrycno][0] = $tmp[0];
		$entryc[$entrycno][1] = $tmp[1];
		if($tmp[2] =~ /^(.*)(.*)$/) {
		    $entryc[$entrycno][2] = $1;
		    $tmptno = $entrytn{$2};
		    if(!$tmptno) {
			$tmptno = 0;
		    }
		    $entryc[$entrycno][0] = $entryt[$tmptno][0];
		    $entryc[$entrycno][3] = $entryt[$tmptno][1];
		    $entryc[$entrycno][4] = $tmptno;
		    if($entrycn{"$entryc[$entrycno][2]$entryc[$entrycno][3]"}) {
			$entrycno--;
		    } else {
			$entrycn{"$entryc[$entrycno][2]$entryc[$entrycno][3]"} = $entrycno;
		    }
		} else {
		    $entryc[$entrycno][2] = $tmp[2];
		    $entryc[$entrycno][3] = "";
		    $entryc[$entrycno][4] = 0;
		    if($entrycn{"$entryc[$entrycno][2]"}) {
			$entrycno--;
		    } else {
			$entrycn{"$entryc[$entrycno][2]"} = $entrycno;
		    }
		}
	    }
	}
    }

    if(-e $newcharfile) {
	open CSV, "<:encoding(shift-jis)", $newcharfile;
	while(<CSV>) {
	    chop;
	    if(/,/) {
		$entrycno++;
		$entryc[$entrycno][6] = $_;
		@tmp = split(/,/);
		$entryc[$entrycno][6] =~ s/^(.*?),(.*?),(.*?),//;
		$entryc[$entrycno][6] = "$timestr,$entryc[$entrycno][6]";
		$entryc[$entrycno][0] = $tmp[0];
		$entryc[$entrycno][1] = $tmp[1];
		if($tmp[2] =~ /^(.*)(.*)$/) {
		    $entryc[$entrycno][2] = $1;
		    $tmptno = $entrytn{$2};
		    if(!$tmptno) {
			$tmptno = 0;
		    }
		    $entryc[$entrycno][0] = $entryt[$tmptno][0];
		    $entryc[$entrycno][3] = $entryt[$tmptno][1];
		    $entryc[$entrycno][4] = $tmptno;
		    if($entrycn{"$entryc[$entrycno][2]$entryc[$entrycno][3]"}) {
			$entrycno--;
		    } else {
			$entrycn{"$entryc[$entrycno][2]$entryc[$entrycno][3]"} = $entrycno;
		    }
		} else {
		    $entryc[$entrycno][2] = $tmp[2];
		    $entryc[$entrycno][4] = 0;
		    if($entrycn{"$entryc[$entrycno][2]"}) {
			$entrycno--;
		    } else {
			$entrycn{"$entryc[$entrycno][2]"} = $entrycno;
		    }
		}
	    } elsif(/^UR[hGg[/) {
		last;
	    }
	}
	close(CSV);
    }

}

# entrychar.csv o
sub output_newentry {

    # entrychar.csv
    @tmpchar = ();
    for($i=1; $i<$entrycno+1; $i++) {
	$tmpline = "$entryto[$entryc[$i][4]],$entryc[$i][0],$entryc[$i][1],";
	if($entryc[$i][3]) {
	    $tmpline .= "$entryc[$i][2]$entryc[$i][3],";
	} else {
	    $tmpline .= "$entryc[$i][2],";
	}
	$tmpline .= "$entryc[$i][6]";
	push(@tmpchar, $tmpline);
    }
    
    open CSV, ">:encoding(shift-jis)", $charfile;
    foreach (sort(@tmpchar)) {
	s/^(\d+,)//;
	print CSV "$_\n";
    }
    close(CSV);
}
